.lib " "

; * String Library
; Last modified: 2012-08-06

; functions

String_TrailingBackslash$( path$ )
String_RemoveTrailingBackslash$( path$ )
String_GetFileName$( LookIn$ , Separator$ )  ; optional
String_GetPathName$( FileSpec$ , Separator$ )  ; optional
String_RemoveExtension$( name$ )
String_GetFileExtension$( name$ )

String_TranslateChars$( s$ , format )  ; optional
String_SwapChars$( msg$ , pos1 , pos2 )
String_FillChars$( original$ , fillwith$ , where% )
String_FillChar$( ori$ , char$ , pos% )
String_Flip$( In$ )
String_Shift$( msg$ , places )
String_Scramble$( msg$ , algorithm )  ; optional
String_Replace$( oldtext$ , source$ , target$ , recursive )  ; optional
String_ReplaceHere$( Source$ , Pos,Size , ReplaceWith$ )
String_ReplaceChars$( source$ , chars_to_replace$ , replace_with$ )

String_TabsToSpaces$( In$ , TabWidth , TabAsc )  ; optional (2)
String_BooleanText$( BooleanValue , Format$ , NumParams )  ; optional (2)
;String_BooleanText$( BooleanValue , Format$ )  ; optional
String_FormatColor$ ( Red , Green , Blue )
String_WithCommas$ ( Value$ )
String_FormatBytes$( Value )
String_FormatTime$( ms )
String_CurrentTimestamp$( format )  ; optional
String_FormatValue$( Value# , Digits , Pad )  ; optional (2)
String_Numberth$( number$ )

String_InsertChars$( Source$ , Pos , InsertChars$ )
String_Leading$( In$ , Char$ )
String_Trailing$( In$ , Char$ )
String_GenerateGarbage$( Width , Min , Max )  ; optional (3)
String_PadValue$ ( Value , Length , Fill$ )  ; optional
String_PadLeft$ ( Text$ , PadAmount , PadChar$ )  ; optional
String_PadRight$ ( Text$ , PadAmount , PadChar$ )  ; optional
String_PadCenter$( Text$ , Amount , PadChar$ )  ; optional
String_EnfoldChars$( In$ , Head$,Tail$ )  ; optional (1)

String_NoLeading$( In$ , Char$ )
String_NoTrailing$( In$ , Char$ )
String_UnfoldChars$( In$ , Head$,Tail$ )  ; optional (1)
String_Trim$( Source$ )
String_WipeLeft$( Source$ , AmountOfChars )
String_WipeRight$( Source$ , AmountOfChars )
String_WipeLeading$( This$ , Lead$ )
String_WipeTrailing$( This$ , Tail$ )
String_RightOf$( Source$ , WhereFrom )
String_CutLineFeed$( Source$ )
String_CutQuotes$( Source$ )
String_SimplifyQuotes$( Source$ )
String_ConstrictSentence$( sentence$ , new_length , separator$ , edge_separator$ )  ; optional (2)

String_MatchMask( Parse$ , Mask$ )
String_Search( search_in$ , search_for$ , offset% )  ; optional
String_CountChars( Source$ , FindChar$ )
;String_CountStrings_1( Source$ , FindTarget$ )
String_CountStrings%( source$ , find$ )
String_RightIs( Source$ , CompareWith$ )
String_LeftIs( Source$ , CompareWith$ )
String_MidIs ( MainText$ , Position% , SubText$ )
String_IsNumber ( This$ )
String_CharIsAlpha( Char$ )
String_CharIsAlphaNum( Char$ )
String_CharIsSign( Char$ )
String_CharIsSpace( Char$ )
String_CharType( Char$ )
String_CharFromHere ( Text$ , Chars$ , Where% )  ; optional
String_NonCharFromHere ( Text$ , Chars$ , Where% )  ; optional
String_SpaceFromHere ( Text$ , Where% , Space$ )  ; optional
String_SpaceBackThere ( Text$ , Where% , Space$ )  ; optional
String_HasOnlyTheseChars( sentence$ , charlist$ )

String_FillParameters%( IN$ , SEP$ , CONSEC% )  ; optional (2)
String_CutFirstParameter$ ( Source$ )
String_Parameter$ ( From$ , Which% , Space$ , Quote$ )  ; optional (2)
String_ParameterCount ( From$ , Space$ , Quote$ )  ; optional (2)
String_ContainsParameter ( Source$ , Parameter$ , Separator$ , Quote$ )  ; optional (2)
String_ParameterPos( From$ , Which% , Space$ , Quote$ )  ; optional (2)
String_MatchParameter( source$ , find$ , sep$ )  ; optional (1)
String_RandomPick$( IN$ , SEP$ )  ; optional (1)
String_AddParameter$( source$ , add$ , sep$ , allow_empty_parameters )  ; optional (2)

; arrays

String_Parameters$( parameter_index )  ; blitz array (!)
